package com.example.johannes.bluetoothtestapp;

import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.util.Log;

import java.io.IOException;
import java.util.UUID;
import java.util.logging.Handler;

public class connection_bt extends Thread {
    private static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");

    private manageconnection_bt con1_sock;
    private BluetoothSocket bSocket;
    private final BluetoothDevice bDevice;
    private android.os.Handler handler;

    public connection_bt(BluetoothDevice device, android.os.Handler handler) { //Konstruktor mti Parametern!!! ja auch in c++
        BluetoothSocket tmp = null;
        bDevice = device;
        try {
            Log.e("Bluetooth:", "Socket aufbauen...");
            tmp = device.createInsecureRfcommSocketToServiceRecord(MY_UUID);
        } catch (IOException start_connect) {}
        this.handler = handler;
        bSocket = tmp;
    }
    public void start() {
        BluetoothSocket tmp = null;
        try {
            Log.e("Bluetooth:", "Starte Verbindungsaufbau...");
            bSocket.connect();
        } catch (IOException build_connect) {
            try {
                Log.e("Bluetooth:", "Normaler Verbindungsaufbau gescheitert...");
                Log.e("Bluetooth:", "Starte erweitereten Verbindungsaufbau");
                bSocket = (BluetoothSocket) bDevice.getClass().getMethod("createInsecureRfcommSocket", new Class[] {int.class}).invoke(bDevice,1);
                Log.e("Bluetooth:", "Starte Verbindungsaufbau...");
                bSocket.connect();
            } catch (Exception build_connect2) {
                Log.e("Bluetooth:", "Fehler Verbindung", build_connect2);
                Log.e("Bluetooth:", "Verbindung kann nicht aufgebaut werden!");
            }
        }
        if (bSocket.isConnected()) {
            Log.e("Bluetooth:", "Verbunden!");
            con1_sock = new manageconnection_bt(bSocket, handler);
            con1_sock.start();
        }
    }
    public void write(String s) {
        con1_sock.write(s);
    }
    public void stop_connection() {
        try {
            Log.e("Bluetooth:","Stoppe Verbindungsaufbau / Verbindung");
            bSocket.close();
            con1_sock.close();
            con1_sock.isInterrupted();
        } catch (IOException close_connect) {}
    }
}

